//CALENDAR

var Schedule = {

    // JSON results for show dates and times will be stored here
    Times : null,
    Avail : null,

    // Get JSON file, call appropriate parsing function after
    Fetch : function (source, callback) {
        $.getJSON (source, function (data) {
            // Format dates if Ticketmaster calendar

      //console.log(data.contents);
            if (data.contents) {
                Schedule.Times = data.contents;
                for (key in Schedule.Times) {
                    var date = (Schedule.Times [key].event_SEO_name.slice (-10)).split ("-");
                    Schedule.Times [key].date = date [2] + '-' + date [0] + '-' + date [1];
                }
            } else {
                Schedule.Times = data;
            }
            callback ();
        });
    },


    // Initalize calendar in container, pass it parsed events list array with
    // ticket links
    Populate : function (container, eventslist) {

        // Figure out first and last performances
        var maxdate = new Date (Schedule.Times [Schedule.Times.length - 1].date);
        var mindate;
        if (new Date (Schedule.Times [0].date) >= new Date ()) {
            mindate = new Date (Schedule.Times [0].date);
        } else {
            mindate = new Date ();
        }



        for (var i = 0; i < eventslist.length; i++) {

          var eventDate = "." + eventslist[i].start;
          var eventTime = eventslist[i].title.slice(0, -2);
          var typeShow = eventslist[i].showClass;
          var timeShow = eventslist[i].showTime;

          //console.log(eventDate);
          var eventInfo = "<a class='event num" + (i + 1) + " " + typeShow + " " + timeShow + " showlink' onclick=\"ga('send', 'event', 'site event', 'ticket click', 'Ticketmaster Calendar Event');\" target='blank' /*data-showdate='" + eventslist[i].cleanDate + "' */data-showtime='" + eventTime + "' href='"+ eventslist[i].url +"'>" + eventTime + "</a>";
          $('.month').find(eventDate).append(eventInfo);
        }

    },

    // HUDSON THEATER LINK PULL
    Telecharge : function (container) {
        var eventslist = [];

        //Date fix
        var calDate = new Date();
        calDate.setDate(calDate.getDate() - 1);

        //console.log(Schedule.Times);
        var dateformatted = "";
        var timeformatted = "";
        var showName = "";
        var showToD = ""

        for (var i=0; i < Schedule.Times.length; i++) {

            dateformatted = (Schedule.Times [i].date).split ("-");
            dateformatted = eval(dateformatted[1])+"/"+dateformatted[2]+"/"+dateformatted[0];

            if (Schedule.Times[i].show === "itar") {
              showName = "Is-This-A-Room"
            } else {
              showName = "Dana-H"
            }

            if (Schedule.Times[i].showtime === "8:00 PM" || Schedule.Times[i].showtime === "7:00 PM" || Schedule.Times[i].showtime === "7:30 PM") {
              showToD = "eve"
            } else {
              showToD = "mat"
            }



            timeformatted = "0" + Schedule.Times [i].showtime.substr(0,4) + "PM";

            if (calDate <= new Date (Schedule.Times [i].date)) {
                eventslist.push ({
                    start : Schedule.Times [i].date,
                    url : 'https://www.telecharge.com/Broadway/' + showName + '/Ticket?PerformanceDateTime=' + dateformatted + '%20' + timeformatted,
                    title : Schedule.Times [i].showtime,
                    type : "Telecharge",
                    cleanDate : dateformatted,
                    showTime : showToD,
                    showClass: Schedule.Times [i].show
                });
            }
        }
        Schedule.Populate (container, eventslist);
    }
  };



$(document).ready(function(){

  var months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];

  // get today's date
  var d = new Date();
  var m = d.getMonth();
  var y = d.getFullYear();
  var ind = 1; // starting index number (for select operations)
  var numMonths = 4; // number of months to be generated

  var calText = "";
  document.getElementById("cal").innerHTML = calText;

  for (var i = 0; i < numMonths; i++) {

    var numDays = daysInMonth(m+1,y);

    var first = new Date(y,m,1);

    var frontpad = first.getDay();
    var afterpad = (7 - ((frontpad + numDays) % 7)) % 7;

    calText = "<div class=\"month cal-mon-" + m + "\">";

    calText += "<div class=\"hed\"><div class=\"month-wrap\"><h3 class='bg-line'><span>" + months[m] + " " + y + "</span></h3><i id=\"cal-open\"class=\"fas fa-caret-down\"></i><i id=\"cal-closed\" class=\"fas fa-caret-right active\"></i></div></div><div class=\"month-box\"><div class=\"hed-day\">SUN<span class=\"hidden-xs\">DAY</span></div><div class=\"hed-day\">MON<span class=\"hidden-xs\">DAY</span></div><div class=\"hed-day\">TUE<span class=\"hidden-xs\">SDAY</span></div><div class=\"hed-day\">WED<span class=\"hidden-xs\">NESDAY</span></div><div class=\"hed-day\">THU<span class=\"hidden-xs\">RSDAY</span></div><div class=\"hed-day\">FRI<span class=\"hidden-xs\">DAY</span></div><div class=\"hed-day\">SAT<span class=\"hidden-xs\">URDAY</span></div>";
    for (var j = 1; j <= frontpad; j++) {
      calText += "<div class=\"day box-" + j +" \"></div>";
    }

    for (var j = 1; j <= numDays; j++) {
      if (m < 9) {
        if (j <= 9) {
           var thisDate = y + "-" +  "0" + (m+1) + "-0" + j;
        } else {
          var thisDate = y + "-" +  "0" + (m+1) + "-" + j;
        }
      } else {
        if (j <= 9) {
          var thisDate = y + "-" + (m+1) + "-0" + j;
        } else {
          var thisDate = y + "-" +  (m+1) + "-" + j;
        }
      }
      calText += "<div class=\"day active ed-"+thisDate+" "+thisDate+" ind"+ind+"\" data-date=\""+thisDate+"\" data-ind=\""+ind+"\"><span class=\"num\">" + j + "</span></div>";
      ind++;
    }

    for (var j = 1; j <= afterpad; j++){
      calText += "<div class=\"day btm-box-" + j +" \"></div>";
    }

    calText += "<div class='legend clearfix'><div class='itar-color'>IS THIS A ROOM PERFORMANCES <span class='itar-box'></span></div><div class='dana-color'>DANA H. PERFORMANCES <span class='dana-box'></span></div>";

    calText += "</div>";

    m++;

    if (m==12) {
      m = 0;
      y++;
    }

    document.getElementById("cal").innerHTML += calText;
    document.getElementById("cal-dana").innerHTML += calText;

    calText = "";

  }

  //Month is 1 based
  function daysInMonth(month,year) {
    return new Date(year, month, 0).getDate();
  }


    /* --- CAL FUNCTIONS --*/
    var curMonth = 1;
    var curDate = "";
    var numViewable = 7; // number of months that should be viewable at one time

    for (i=curMonth;i<=(curMonth+numViewable-1);i++) {
      $(".month:nth-child("+i+")").addClass("active");
    }

    $(".cal-next, .cal-prev").click(function(e){

      e.preventDefault();

      $(".month").removeClass("active");

      if( $(this).hasClass("cal-next") ){

        curMonth++;
        if( curMonth == 2 ){ $(".cal-prev").show(); }
        if( (curMonth+numViewable-1) == $(".month").length ){ $(".cal-next").hide(); }
        if( curMonth == 1){ $('.cal.prev').hide(); }

      } else {

        curMonth--;
        if( curMonth == 1 ){ $(this).hide(); }
        if( (curMonth+numViewable-1) == ($(".month").length - 1) ){ $(".cal-next").show(); }
        if( curMonth == 1){ $('.cal.prev').hide(); }
      }

      for (i=curMonth;i<=(curMonth+numViewable-1);i++) {
        $(".month:nth-child("+i+")").addClass("active");
      }

    });

      Schedule.Fetch("_data/schedule.json", function(){
        Schedule.Telecharge("#cal");
    });


    function firstMonFix() {
      $('.cal-mon-9 #cal-open').addClass('active');
      $('.cal-mon-9 #cal-closed').removeClass('active');
      $('.cal-mon-9 .month-wrap h3').addClass('active');
    }

    firstMonFix();

    $('.month-wrap i').click(function(e){
      e.preventDefault();
      if($(this).is("#cal-open")) {
        $('.month-wrap i#cal-open').removeClass('active');
        $('.month-wrap i#cal-closed').addClass('active');
        $(this).siblings('h3').removeClass('active');
        $(this).parent('.month-wrap').parent('.hed').parent('.month').children('.month-box').hide();
        $(this).removeClass('active');
        $(this).siblings('i').addClass('active');
      } else {
        $('.month-box').hide();
        $('.month-wrap i#cal-open').removeClass('active');
        $('.month-wrap i#cal-closed').addClass('active');
        $('.month-wrap h3').removeClass('active');
        $(this).siblings('h3').addClass('active');
        $(this).parent('.month-wrap').parent('.hed').parent('.month').children('.month-box').show();
        $(this).removeClass('active');
        $(this).siblings('i').addClass('active');
      }

    });

    $('.month-wrap h3').click(function(e){
      e.preventDefault();
      if($(this).hasClass("active")) {
        $('.month-wrap i#cal-open').removeClass('active');
        $('.month-wrap i#cal-closed').addClass('active');
        $(this).parent('.month-wrap').parent('.hed').parent('.month').children('.month-box').hide();
        $(this).siblings('i#cal-open').removeClass('active');
        $('.month-box').hide();
        $(this).removeClass('active');
        $(this).siblings('i#cal-closed').addClass('active');
      } else {
        $('.month-box').hide();
        $('.month-wrap h3').removeClass('active');
        $('i#cal-open').removeClass('active');
        $('i#cal-closed').addClass('active');
        $(this).siblings('i#cal-closed').removeClass('active');
        $(this).parent('.month-wrap').parent('.hed').parent('.month').children('.month-box').show();
        $(this).addClass('active');
        $(this).siblings('i#cal-open').addClass('active');
      }

    });

  });
