/**
 * core.js - all global scripts belong in this file.
 */

// NAMESPACE FOR COMMON FUNCTIONS/OBJECTS
var COMMONUTILS = {
    //
    pageWidth : function () {"use strict";
        return document.documentElement.clientWidth;
    },

    // OBJ TO HOLD USERS CURRENT WEBPAGE LOCATION
    currentPage : window.location.pathname.substring (window.location.pathname.lastIndexOf ('/') + 1),

    // FUNCTION TO EXECUTE CODE BASED ON LOCATION
    userLocation : function (pagename) {"use strict";
        var page = pagename;
        $ ('#nav a').removeClass ('active');
        switch(page) {
            case 'index':
                $ ('#nav-home').addClass ('active');
                break;
            case 'about':
                $ ('#nav-about').addClass ('active');
                break;
            case 'cast':
                $ ('#nav-cast').addClass ('active');
                break;
            case 'news':
                $ ('#nav-news').addClass ('active');
                break;
            case 'reviews':
                $ ('#nav-reviews').addClass ('active');
                break;
            case 'tickets':
                $ ('#nav-tickets').addClass ('active');
                break;
            case 'gallery':
                $ ('#nav-gallery').addClass ('active');
                break;
            case 'privacy':
                $ ('#nav a').removeClass ('active');
                break;
            default:
                // No Case
                $ ('#nav-home').addClass ('active');
        }
    },

    optinFormValidate: function() {
    	"use strict";

      var formName = "";

      $(".subscribe").each(function(i){

      	//console.log(i);
      	formName = "optin"+i;
      	$(this).attr("id",formName);

          //
          $(this).validate({
            rules : {
              email : { required : true, email : true }/*,
              zip : 'required'*/
            },
            messages : {
              email : 'your email here'/*,
              zip : 'Enter your zip code'*/
            },
            errorPlacement : function(error, element) {
              element.attr('placeholder', error[0].outerText);
            },
            submitHandler : function(form) {
              $.ajax({
                url : './_inc/optin_action.php',
                type : 'POST',
                data : $(form).serialize() + '&ajax=true',
                success : function() {
                  $(form).hide();
                  $(form).parent("div").append('<h3 class="text-center form-thanks">THANK YOU FOR SIGNING UP.<br /><span>Check your email to confirm your subscription</span></h3>');
                }
              });
              return false;
            }
          });

      });
    },

    nav: function() {
    	"use strict";

    	$("#btn-menu").on("click",function(e){
      	e.preventDefault();
      	if( $("#nav").hasClass("open") ){
        	$("#nav, #btn-menu").removeClass("open");
        	$("#btn-menu").removeClass("fa-times-thin").addClass("fa-bars");
      	} else {
        	$("#nav, #btn-menu").addClass("open");
        	$("#btn-menu").addClass("fa-times-thin").removeClass("fa-bars");
      	}
    	});

    	$("#icon-envelope").click(function(){
      	$("html").addClass("modal-open");
    	});

    },

    video: function() {
    	"use strict";

    	$(".video-link").each(function(e){
      	  if( $(this).data("thumb") != "" ){
        	  $(this).html('<div class="video-thumb"><img src="'+ $(this).data("thumb") +'" class="w100"></div>');
      	  } else {
        	  $(this).html('<div class="video-thumb"><img src="http://img.youtube.com/vi/'+ $(this).data("id") +'/hqdefault.jpg" class="w100"></div>');
      	  }
      	  if( $(this).data("caption") != "" ){
      	    //console.log('yo');
        	  $(this).append("<div class='video-caption'>"+$(this).data("caption")+"</div>");
      	  }
    	});

    	$(document).on("click",".video-link",function(e){
    	    e.preventDefault();
    	    if( $("#video-overlay-close").length == 0 ){
      	    $("#video-overlay").append('<a id="video-overlay-close"></a>');
    	    }
        	$("#video-overlay-inner").html('<iframe src="https://www.youtube.com/embed/'+ $(this).data("id") +'?rel=0&modestbranding=1&autohide=1&showinfo=0&autoplay=1" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>');
        	$("html").addClass("video-overlay-open");
    	});

    	$(document).on("click","#video-overlay-close, #video-overlay",function(e){
    	    e.preventDefault();
        	$("#video-overlay-inner").html('');
        	$("html").removeClass("video-overlay-open");
    	});

    },

    quotes: function() {
    	"use strict";
      $('#quotes').quote_rotator();

    }
};

//Namespace for bio functions
var bioGrid = {};

bioGrid.bioindex = 0;
bioGrid.bios = [];

bioGrid.loadBios = function (divID, page) {"use strict";
    //Cast & Creative Bios
    $(divID).load(page, null, function () {
        //
        if (divID === "#itar-cast-bios") {
            var thumbs = "";
            for (var i=1; i <= $("#itar-cast-bios .team-member").length; i++) {
                thumbs += '<a class="cast-member actor-' + i + '" href="#' + (i - 1) + '" ><div class="cast-image">' + $('#itar-cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-role">' + $('#itar-cast-bios .team-member:nth-child(' + i + ') h3 em').html() + '</div><div class="cast-name">' + $('#itar-cast-bios .team-member:nth-child(' + i + ') h3 strong').html() + '</div></a>';
                bioGrid.bios.push($('#itar-cast-bios .team-member:nth-child('+i+')').html());
              }
              bioGrid.loadBios('#itar-creative-bios','creative-itar.html');


        } else if (divID === "#itar-creative-bios") {
            var thumbs = "";
            for (var j=1; j <= $("#itar-creative-bios .team-member").length; j++) {
                thumbs += '<a class="cast-member actor-' + bioGrid.bios.length + '" href="#' + bioGrid.bios.length + '" ><div class="cast-image">' + $('#itar-creative-bios .team-member:nth-child(' + j + ') .castpic').html() + '</div><div class="cast-role">' + $('#itar-creative-bios .team-member:nth-child(' + j + ') h3 em').html() + '</div><div class="cast-name">' + $('#itar-creative-bios .team-member:nth-child(' + j + ') h3 strong').html() + '</div></a>';
                bioGrid.bios.push($('#itar-creative-bios .team-member:nth-child('+ j +')').html());
              }
              bioGridDana.loadBios('#dana-cast-bios','cast-dana.html');
        }


        $(divID).html(thumbs);
        setTimeout(() => { $('body').addClass('bio-loaded'); }, 1000);


        $(divID + " .cast-member").click( function(e) {
            e.preventDefault();
            bioGrid.bioindex = Number($(this).attr("href").split("#")[1]);

            //add overlay
            $("#overlay-inner").html("").html("<div>" + bioGrid.bios [ ($(this).attr("href").split("#") [1]) ] + "</div>");
            $("html, body").addClass ("overlay-open");
            $(".overlay").addClass ("open");


            //next/prev
            $(".overlay-prev, .overlay-next").show();
            if (bioGrid.bioindex == (bioGrid.bios.length - 1)) {
                $(".overlay-next").hide();
            } else if (bioGrid.bioindex == 0) {
                $(".overlay-prev").hide();
            }

            //scroll, if necessary
            if ( $('.overlay .container').height() > $(window).height() ) {
                var slideheight = $(window).height () - $(".overlay-close").height()*2 - 100;
                $('#overlay-inner > div').slimscroll ({
                    height : slideheight + 'px', alwaysVisible : true, color : '#2dc2cd', railVisible : true, railColor : '#000'
                });
            }
        });
    })
};

//Next/Previous navigation
bioGrid.bioNav = function () {
    $(".overlay-next").click(function(e) {
        e.preventDefault();
        $(".overlay-prev").show();
        $('.overlay-prev').removeClass('end');
        bioGrid.bioindex = bioGrid.bioindex + 1;
        if (bioGrid.bioindex == 15) { //6
            $(this).hide();
            $('.overlay-next').addClass('end');
        }
        else {
          $(this).show();
        }
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });

    $(".overlay-prev").click(function(e) {
        e.preventDefault();
        $(".overlay-next").show();
        $('.overlay-next').removeClass('end');
        if (bioGrid.bioindex == 1) {
            $(this).hide();
            $('.overlay-prev').addClass('end');
        }
        else { $(this).show(); }
        bioGrid.bioindex = bioGrid.bioindex - 1;
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });
};

// Close Cast Overlay
bioGrid.hideOverlay = function () {
    $ (".overlay-close").click (function (e) {
        e.preventDefault ();
        $ ("html, body").removeClass ("overlay-open");
        $ (".overlay").removeClass ("open");
    });
};


//Namespace for bio functions || DANA
var bioGridDana = {};

bioGridDana.bioindex = 0;
bioGridDana.bios = [];

bioGridDana.loadBios = function (divID, page) {"use strict";
    //Cast & Creative Bios
    $(divID).load(page, null, function () {
        //
        if (divID === "#dana-cast-bios") {
            var thumbs = "";
            for (var i=1; i <= $("#dana-cast-bios .team-member").length; i++) {
                thumbs += '<a class="cast-member actor-' + i + '" href="#' + (i - 1) + '" ><div class="cast-image">' + $('#dana-cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-role">' + $('#dana-cast-bios .team-member:nth-child(' + i + ') h3 em').html() + '</div><div class="cast-name">' + $('#dana-cast-bios .team-member:nth-child(' + i + ') h3 strong').html() + '</div></a>';
                bioGridDana.bios.push($('#dana-cast-bios .team-member:nth-child('+i+')').html());
              }
              bioGridDana.loadBios('#dana-creative-bios','creative-dana.html');


        } else if (divID === "#dana-creative-bios") {
            var thumbs = "";
            for (var j=1; j <= $("#dana-creative-bios .team-member").length; j++) {

                thumbs += '<a class="cast-member actor-' + bioGridDana.bios.length + '" href="#' + bioGridDana.bios.length + '" ><div class="cast-image">' + $('#dana-creative-bios .team-member:nth-child(' + j + ') .castpic').html() + '</div><div class="cast-role">' + $('#dana-creative-bios .team-member:nth-child(' + j + ') h3 em').html() + '</div><div class="cast-name">' + $('#dana-creative-bios .team-member:nth-child(' + j + ') h3 strong').html() + '</div></a>';
                bioGridDana.bios.push($('#dana-creative-bios .team-member:nth-child('+ j +')').html());


              }
        }






        $(divID).html(thumbs);
        setTimeout(() => { $('body').addClass('bio-loaded'); }, 1000);


        $(divID + " .cast-member").click( function(e) {
            e.preventDefault();
            bioGridDana.bioindex = Number($(this).attr("href").split("#")[1]);

            //add overlay
            $("#overlay-inner-dana").html("").html("<div>" + bioGridDana.bios [ ($(this).attr("href").split("#") [1]) ] + "</div>");
            $("html, body").addClass ("overlay-open");
            $(".overlay-dana").addClass ("open");


            //next/prev
            $(".overlay-prev, .overlay-next").show();
            if (bioGridDana.bioindex == (bioGridDana.bios.length - 1)) {
                $(".overlay-next-dana").hide();
            } else if (bioGridDana.bioindex == 0) {
                $(".overlay-prev-dana").hide();
            }

            //scroll, if necessary
            if ( $('.overlay-dana .container').height() > $(window).height() ) {
                var slideheight = $(window).height () - $(".overlay-close-dana").height()*2 - 100;
                $('#overlay-inner-dana > div').slimscroll ({
                    height : slideheight + 'px', alwaysVisible : true, color : '#2dc2cd', railVisible : true, railColor : '#000'
                });
            }
        });
    })
};

//Next/Previous navigation
bioGridDana.bioNav = function () {
    $(".overlay-next-dana").click(function(e) {
        e.preventDefault();
        $(".overlay-prev-dana").show();
        $('.overlay-prev-dana').removeClass('end');
        bioGridDana.bioindex = bioGridDana.bioindex + 1;
        if (bioGridDana.bioindex == 14) {
            $(this).hide();
            $('.overlay-next-dana').addClass('end');
        }
        else {
          $(this).show();
        }
        $("#overlay-inner-dana").fadeOut(300, function() {
            $(this).html(bioGridDana.bios[bioGridDana.bioindex]).fadeIn(500);
        });
    });

    $(".overlay-prev-dana").click(function(e) {
        e.preventDefault();
        $(".overlay-next-dana").show();
        $('.overlay-next-dana').removeClass('end');
        if (bioGridDana.bioindex == 1) {
            $(this).hide();
            $('.overlay-prev-dana').addClass('end');
        }
        else { $(this).show(); }
        bioGridDana.bioindex = bioGridDana.bioindex - 1;
        $("#overlay-inner-dana").fadeOut(300, function() {
            $(this).html(bioGridDana.bios[bioGridDana.bioindex]).fadeIn(500);
        });
    });
};

// Close Cast Overlay
bioGridDana.hideOverlay = function () {
    $ (".overlay-dana .overlay-close-dana").click (function (e) {
        e.preventDefault ();
        $ ("html, body").removeClass ("overlay-open");
        $ (".overlay-dana").removeClass ("open");
    });
};

// jQuery Namespace
$ (document).ready (function () {"use strict";
    $('html').addClass('page-loaded');
    COMMONUTILS.optinFormValidate();
    /*bioGrid.loadBios('#itar-cast-bios','cast-itar.html');
    bioGrid.bioNav();
    bioGrid.hideOverlay();
    bioGridDana.bioNav();
    bioGridDana.hideOverlay();*/


    //SPLIT PAGE
    $('.itar-select').click(function(e) {
      window.open('https://isthisaroombroadway.com', '_blank');
    });

    /*$('.itar-back').click(function(e) {
      e.preventDefault();
      $('#isthis-page').removeClass('slideInLeft');
      $('#isthis-page').addClass('slideOutLeft');
      $('section#home').removeClass('slideOutRight');
      $('section#home').addClass('slideInRight');
      $('#isthis-page').addClass('hidden');
      $(this).removeClass('active');
    });*/


    $('.dana-select').click(function(e) {
      window.open('https://danahbroadway.com', '_blank');
    });

    /*$('.dana-back').click(function(e) {
      e.preventDefault();
      $('#dana-page').removeClass('slideInRight');
      $('#dana-page').addClass('slideOutRight');
      $('section#home').removeClass('slideOutLeft');
      $('section#home').addClass('slideInLeft');
      $('#dana-page').addClass('hidden');
      $(this).removeClass('active');
    });


    $('.tix-tab').click(function(e) {
      e.preventDefault();
      if ($(this).hasClass('active')) {
        $(this).removeClass('active');
        $('#cal').removeClass('active');
        $('#cal-dana').removeClass('active');
        $('.map-tab').addClass('active');
        $('#itar-info').addClass('active');
        $('#dana-info').addClass('active');
      } else {
        $(this).addClass('active');
        $('#cal').addClass('active');
        $('#cal-dana').addClass('active');
        $('.map-tab').removeClass('active');
        $('#itar-info').removeClass('active');
        $('#dana-info').removeClass('active');
      }
    });

    $('.map-tab').click(function(e) {
      e.preventDefault();
      if ($(this).hasClass('active')) {
        $(this).removeClass('active');
        $('#itar-info').removeClass('active');
        $('#dana-info').removeClass('active');
        $('.tix-tab').addClass('active');
        $('#cal').addClass('active');
        $('#cal-dana').addClass('active');
      } else {
        $(this).addClass('active');
        $('#itar-info').addClass('active');
        $('#dana-info').addClass('active');
        $('.tix-tab').removeClass('active');
        $('#cal').removeClass('active');
        $('#cal-dana').removeClass('active');
      }
    });*/



    function mobileDirect(){
      var pgWidth = document.documentElement.clientWidth;
      if (pgWidth < 1000) {
        var barHeight = $('.mobile-bar.green-bg').height();
        var btnHeight = $('.itar-main-tix-btn').height();
        var topSpace = barHeight + btnHeight + 40;
        $('.direct').css('top', topSpace);
        $('.itar-main-tix-btn').css('top', (barHeight + 40));
      } else {
        $('.direct').css('top', 66);
        $('.itar-main-tix-btn').css('top', 30);
      }
    }

    //mobileDirect();

    $( window ).resize(function() {
      //mobileDirect();
    });


    //QUOTE ROTATION
    $('#quote-rotate-itar').slick({
     autoplay: true,
     arrows:false,
     autoplaySpeed:5000
   });

   $('#quote-rotate-dana').slick({
     autoplay: true,
     arrows:false,
     rtl:true,
     autoplaySpeed:5000
  });
});

// EOF
